program FishFactsServer;
{$APPTYPE CONSOLE}

{$R *.dres}

uses
  System.SysUtils,
  Winapi.Windows,
  IdHTTPWebBrokerBridge,
  Web.WebReq,
  Web.WebBroker,
  WebModule in 'WebModule.pas' {FishFactsWebModule: TWebModule},
  FishFactsServerMethods in 'FishFactsServerMethods.pas',
  DataModuleMS in 'DataModuleMS.pas' {FactsDataModule: TDataModule},
  DDatabase in 'DDatabase.pas' {dmDatabase: TDataModule};

{$R *.res}

procedure RunServer(APort: Integer);
var
  LInputRecord: TInputRecord;
  LEvent: DWord;
  LHandle: THandle;
  LServer: TIdHTTPWebBrokerBridge;
begin
  Writeln(Format('HTTP-Server auf Port %d wird gestartet', [APort]));
  LServer := TIdHTTPWebBrokerBridge.Create(nil);
  try
    LServer.DefaultPort := APort;
    LServer.Active := True;
    Writeln('Drcken Sie ESC, um den Server anzuhalten');
    LHandle := GetStdHandle(STD_INPUT_HANDLE);
    while True do
    begin
      Win32Check(ReadConsoleInput(LHandle, LInputRecord, 1, LEvent));
      if (LInputRecord.EventType = KEY_EVENT) and
      LInputRecord.Event.KeyEvent.bKeyDown and
      (LInputRecord.Event.KeyEvent.wVirtualKeyCode = VK_ESCAPE) then
        break;
    end;
  finally
    LServer.Free;
  end;
end;

function GetPort: Integer;
var
  S: string;
begin
  S := GetEnvironmentVariable('HTTP_PORT');
  result := StrToIntDef(S, 8089);
end;

begin
  try
    if WebRequestHandler <> nil then
      WebRequestHandler.WebModuleClass := WebModuleClass;
    RunServer(GetPort);
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end
end.
